<?php
/**
* @copyright	Copyright (C) 2013 Jsn Project company. All rights reserved.
* @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
* @package		Easy Profile
* website		www.easy-profile.com
* Technical Support : Forum -	http://www.easy-profile.com/support.html
*/

defined('_JEXEC') or die;

class PlgJsnUserImport extends JPlugin
{
	public function __construct(& $subject, $config)
	{
		parent::__construct($subject, $config);
		
	}
	
	public function renderPlugin()
	{
		if(JRequest::getVar('view',false)=='import')
		{
			$user=JFactory::getUser();
			$access=$this->params->def('access', false);
			$userAccess=$user->getAuthorisedViewLevels();
			if(in_array($access,$userAccess))
			{
				UserImport::getInstance()->init();
			}
			else{
				$app=JFactory::getApplication();
				$app->enqueueMessage('Not Authorized','error');
				return;
			}
		}
	}

}

class UserImport
{	
	private $filecontent;
	private $fields;
	public function __construct()
	{
			$this->filecontent='';
	}
	
	public static function getInstance()
	{
		static $cache=null;
		if (!isset($cache))
		{
			$cache=new UserImport();
		}
		return $cache;
	}
	
	public function init()
	{
		if(JRequest::getVar('goimport',false))
		{
			if(isset($_FILES['filecsv']) && !empty($_FILES['filecsv']['name']))
			{
				$filename=$_FILES['filecsv']['tmp_name'];
				$this->filecontent=file_get_contents($filename);
				unlink($filename);
				$this->check();
			}
			else
			{
				$app=JFactory::getApplication();
				$app->enqueueMessage('No file selected','error');
				$this->getForm();
			}
		}
		else
		{
			$this->getForm();
		}
	}
	
	private function getForm()
	{
		echo('
		<div class="page-header"><h2>Import User from CSV</h2></div>
		<div class="alert alert-warning">
			<b>RULES AND NOTE</b>
			<ul>
				<li>When user existing and you choose to override information, the username and password are not changed</li>
				<li>A field should never miss: email, and name or firstname</li>
				<li>Import only from CSV</li>
				<li>The first row of CSV file determines the columns (alias of field)</li>
				<li>Existing user are identified by email</li>
				<li>If there is no specified password field, it will be generated for new users</li>
				<li>If there is no specified username field, it will be generated for new users</li>
			</ul>
			<b>Examples:</b>
			<pre>username;email;password;firstname;lastname
john;john@test.it;passwordofjohn;John;Doe
mark;mark@test.com;passwordofmark;Mark;White</pre>
			<pre>email;password;firstname;lastname;gender
john@test.it;passwordofjohn;John;Doe;male
mark@test.com;passwordofmark;Mark;White;male</pre>
			<pre>email;name;gender
john@test.it;John Doe;male
mark@test.com;Mark White;male</pre>
		</div>
		<div>
		<form method="post" action="'.JRoute::_('index.php?option=com_jsn&view=import').'" class="form-horizontal" name="importcsv" enctype="multipart/form-data">
			<div class="control-group">
				<div class="control-label"><label>File CSV</label></div>
				<div class="controls">
					<input type="file" name="filecsv"/>
				</div>
			</div>
			<div class="control-group">
				<div class="control-label"><label>Overwrite existing user</label></div>
				<div class="controls">
					<label class="checkbox"><input type="checkbox" name="overwrite" value="1" />Yes</label>
				</div>
			</div>
			<div class="control-group">
				<div class="control-label"><label>Send email with access details to New User</label></div>
				<div class="controls">
					<label class="checkbox"><input type="checkbox" name="sendmail" value="1" checked="checked"/>Yes</label>
				</div>
			</div>
			<div class="form-actions">
				<input name="goimport" type="submit" class="btn btn-primary" value="Import" />
			</div>
		</form>
		</div>
		');
	}
	
	private function check()
	{
		$firstRow=explode("\n",$this->filecontent);
		$this->fields=explode(';',str_replace("\r",'',$firstRow[0]));
		$error=false;
		$errorField=array();
		// CHECK REQUIRED FIELDS
		if(!in_array('email',$this->fields))
		{
			$error=true;
			$errorField[]='Email';
		}
		/*if(!in_array('password',$this->fields))
		{
			$error=true;
			$errorField[]='Password';
		}*/
		if(!in_array('name',$this->fields) && !in_array('firstname',$this->fields))
		{
			$error=true;
			$errorField[]='Name or Firstname';
		}
		if($error)
		{
			$app=JFactory::getApplication();
			$app->enqueueMessage('Missing some required fields: '.implode(', ',$errorField),'error');
			$this->getForm();
			return;
		}
		// CHECK KNOW FIELDS
		$db=JFactory::getDbo();
		$query=$db->getQuery(true);
		$query->select('alias')->from('#__jsn_fields')->where($db->quoteName('level').' = 2')->where($db->quoteName('type').' != '.$db->quote('delimeter'));
		$db->setQuery($query);
		$dbFields=$db->loadColumn();
		foreach($this->fields as $field)
		{
			$from=array('_lat','_lng');
			$to=array('','');
			$field=str_replace($from,$to,$field);
			if($field!='name' && !in_array($field,$dbFields))
			{
				$error=true;
				$errorField[]=$field;
			}
		}
		if($error)
		{
			$app=JFactory::getApplication();
			$app->enqueueMessage('Unknown fields: '.implode(', ',$errorField),'error');
			$this->getForm();
			return;
		}
		$this->import();
		//print_r(JRequest::getVar('overwrite',false));
		//print_r($dbFields);
		
	}
	
	private function import()
	{
		$app=JFactory::getApplication();
		// Load language for email
		$lang = JFactory::getLanguage();
		$lang->load('com_users');
		// Sender Details
		$joomlaConfig=JFactory::getConfig();
		$mailSender=$joomlaConfig->get('mailfrom');
		$mailSenderName=$joomlaConfig->get('fromname');
		$siteName = $joomlaConfig->get('sitename');
		$siteUrl = JUri::root();
		
		$users=explode("\n",$this->filecontent);
		unset($users[0]); // Row of fields
		$numFields=count($this->fields);
		$countImported=0;
		$registerDate=date('Y-m-d H:i:s');
		$config = JComponentHelper::getParams('com_users');
		$newUserType=$config->get('new_usertype',2);
		foreach($users as $userRow)
		{
			if(trim($userRow)!='')
			{
				$userFields=explode(';',str_replace("\r",'',$userRow));
				if(count($userFields)!=$numFields)
				{
					$app->enqueueMessage('Num of this row not match with number of declared field: '.$userRow,'error');
				}
				else
				{
					$count=0;
					$importUser=array();
					// MAP FIELDS
					foreach($this->fields as $key=>$value)
					{
						$importUser[$value]=$userFields[$key];
					}
					if(isset($importUser['registerDate'])) unset($importUser['registerDate']);
					if(isset($importUser['block'])) unset($importUser['block']);
					// CHECK USER EXIST
					$db=JFactory::getDbo();
					$query=$db->getQuery(true);
					$query->select('id')->from('#__users')->where($db->quoteName('email').' = '.$db->quote($importUser['email']));
					$db->setQuery($query);
					$exists=$db->loadResult();
					if(!$exists || JRequest::getVar('overwrite',false))
					{
						// IMPORT USER
						if(isset($importUser['name']) && !isset($importUser['firstname']))
						{
							$importUser['firstname']=$importUser['name']; // TODO split name based on JSN config
						}
						elseif(!isset($importUser['name']) && isset($importUser['firstname']))
						{
							$importUser['name']=$importUser['firstname'];
							if(isset($importUser['secondname'])) $importUser['name'].=' '.$importUser['secondname'];
							if(isset($importUser['lastname'])) $importUser['name'].=' '.$importUser['lastname'];
						}
						if(!isset($importUser['username']))
						{
							$importUser['username']=preg_replace( '/\W/', '', str_replace( ' ', '_', stripslashes( $importUser['name'] ) ) ).'_'.rand(0,2000);
						}
						/*if(isset($importUser['password']))
						{
							$salt=JUserHelper::getSalt();
							$importUser['password']=JUserHelper::getCryptedPassword($importUser['password'],$salt);
						}*/
						if($exists)
						{
							// #__users
							$query=$db->getQuery(true);
							$query->update("#__users");
							$query->set($db->quoteName('name').' = '.$db->quote($importUser['name']));
							/*$query->set($db->quoteName('username').' = '.$db->quote($importUser['username']));
							if(isset($importUser['password']))
							{
								$query->set($db->quoteName('password').' = '.$db->quote($importUser['password']));
							}*/
							$query->where('id = '. $exists);
							$db->setQuery($query);
							$db->execute();
							// #__jsn_users
							$query=$db->getQuery(true);
							$query->update("#__jsn_users");
							unset($importUser['name']);
							unset($importUser['email']);
							unset($importUser['username']);
							if(isset($importUser['password'])) unset($importUser['password']);
							foreach($this->fields as $value)
							{
								if(isset($importUser[$value])) $query->set($db->quoteName($value).' = '.$db->quote($importUser[$value]));
							}
							$query->where('id = '. $exists);
							$db->setQuery($query);
							$db->execute();
							$countImported+=1;
						}
						else
						{
							if(isset($importUser['password']))
							{
								$passwordClear=$importUser['password'];
								$salt=JUserHelper::getSalt();
								$importUser['password']=JUserHelper::getCryptedPassword($importUser['password'],$salt);
							}
							else
							{
								$passwordClear=JUserHelper::genRandomPassword();
								$salt=JUserHelper::getSalt();
								$importUser['password']=JUserHelper::getCryptedPassword($passwordClear,$salt);
							}
							if(JRequest::getVar('sendmail',false))
							{
								$emailSubject = JText::sprintf(
									'COM_USERS_EMAIL_ACCOUNT_DETAILS',
									$importUser['name'],
									$siteName
								);
								$emailBody = JText::sprintf(
									'COM_USERS_EMAIL_REGISTERED_BODY',
									$importUser['name'],
									$siteName,
									$siteUrl,
									$importUser['username'],
									$passwordClear
								);
								JFactory::getMailer()->sendMail(
									$mailSender,	// Sender Mail
									$mailSenderName,	// Sender Name
									$importUser['email'],	// Receiver Mail
									$emailSubject,	// Subject Mail
									$emailBody	// Body Mail
								);
							}	
							
							// #__users
							$fields=array();
							$values=array();
							$fields[]=$db->quoteName('name');
							$fields[]=$db->quoteName('username');
							$fields[]=$db->quoteName('email');
							$fields[]=$db->quoteName('block');
							$fields[]=$db->quoteName('registerDate');
							$values[]=$db->quote($importUser['name']);
							$values[]=$db->quote($importUser['username']);
							$values[]=$db->quote($importUser['email']);
							$values[]='0';
							$values[]=$db->quote($registerDate);
							if(isset($importUser['password']))
							{
								$fields[]=$db->quoteName('password');
								$values[]=$db->quote($importUser['password']);
							}
							$query="INSERT INTO #__users(".implode(', ',$fields).") VALUES(".implode(', ',$values).")";
							$db->setQuery($query);
							$db->execute();
							// #__jsn_users
							$userId=$db->insertid();
							$fields=array();
							$values=array();
							unset($importUser['name']);
							unset($importUser['email']);
							unset($importUser['username']);
							if(isset($importUser['password'])) unset($importUser['password']);
							foreach($importUser as $key => $value)
							{
								$fields[]=$db->quoteName($key);
								$values[]=$db->quote($value);
							}
							$query="INSERT INTO #__jsn_users(id,".implode(', ',$fields).") VALUES(".$userId.", ".implode(', ',$values).")";
							$db->setQuery($query);
							$db->execute();
							$countImported+=1;
							// #__user_usergroup_map
							$fields=array();
							$values=array();
							$fields[]=$db->quoteName('user_id');
							$fields[]=$db->quoteName('group_id');
							$values[]=$userId;
							$values[]=$newUserType;
							$query="INSERT INTO #__user_usergroup_map(".implode(', ',$fields).") VALUES(".implode(', ',$values).")";
							$db->setQuery($query);
							$db->execute();
						}
					}
				}
			}
		}
		$app->enqueueMessage($countImported.' user imported','notice');
	}
	
}
?>